=== debian/control ===
--- 
+++ 
@@ -2,12 +2,12 @@
 Maintainer: Fabian Wolff <fabi.wolff@arcor.de>
 Section: libs
 Priority: optional
-Build-Depends: debhelper-compat (= 12),
+Build-Depends: debhelper-compat (= 13),
                libelf-dev,
                zlib1g-dev
 Standards-Version: 4.5.0
 Homepage: https://www.prevanders.net/dwarf.html
-Vcs-Git: https://salsa.debian.org/wolff-guest/dwarfutils.git/
+Vcs-Git: https://salsa.debian.org/wolff-guest/dwarfutils.git
 Vcs-Browser: https://salsa.debian.org/wolff-guest/dwarfutils
 
 Package: dwarfdump
