## dwarfutils 20201201

=== CMakeLists.txt ===
--- 
+++ 
@@ -160,6 +160,13 @@
     NOT HAVE_LIBELF_H AND 
     NOT HAVE_LIBELF_LIBELF_H)
     set(DWARF_WITH_LIBELF OFF)
+    set(HAVE_ELF_H OFF)
+elseif (NOT DWARF_WITH_LIBELF)
+    set(HAVE_ELF_H OFF)
+    set(HAVE_LIBELF_LIBELF_H OFF)
+    set(HAVE_LIBELF_H OFF)
+    set(HAVE_ELF64_GETSHDR OFF)
+    set(HAVE_ELF64_GETEHDR OFF)
 endif ()
 
 if (DWARF_WITH_LIBELF)
@@ -220,6 +227,7 @@
    int i = 12;
    return 0;
   }" HAVE_STRUCT_UNDERSCORE_ELF)
+else()
 endif()
 message(STATUS "Assuming struct Elf for the default libdwarf.h")
 # Because cmake treats ; in an interesting way attempting
@@ -230,11 +238,11 @@
    message(STATUS "Using struct _Elf in libdwarf.h")
    configure_file(libdwarf/generated_libdwarf.h.in 
        libdwarf/libdwarf.h COPYONLY)
-else()
+elseif(NOT DWARF_WITH_LIBELF)
    configure_file(libdwarf/libdwarf.h.in 
        libdwarf/libdwarf.h COPYONLY)
    message(STATUS "${JUST_LIBELF} does not have struct _Elf")
-   message(STATUS "Using struct Elf in libdwarf.h")
+   message(STATUS "Using struct Elf in libdwarf.h, no actual elf.h used")
 endif()
 
 check_c_source_runs("
@@ -301,6 +309,20 @@
       }
       return 0;
   } ]=]  HAVE_ZLIB )
+check_c_source_compiles( [=[
+  #include "zlib.h"
+  int main()
+  {
+      Bytef dest[100];
+      uLongf destlen = 100;
+      Bytef *src = 0;
+      uLong srclen = 3;
+      int res = uncompress(dest,&destlen,src,srclen);
+      if (res == Z_OK) {
+           /* ALL IS WELL */
+      }
+      return 0;
+  } ]=]  HAVE_ZLIB_H )
 set(CMAKE_REQUIRED_LIBRARIES)
 if (HAVE_ZLIB) 
   # For linking in libz
@@ -363,13 +385,3 @@
 option(HAVE_WINDOWS_PATH "Detect certain Windows paths as full paths (default is NO)" FALSE)
 message(STATUS "Checking enable windows path... ${HAVE_WINDOWS_PATH}")
     
-option(HAVE_OLD_FRAME_CFA_COL "Use HAVE_OLD_FRAME_CFA_COL (default is to use new DW_FRAME_CFA_COL3)" FALSE)
-message(STATUS "Checking enable old frame columns... ${HAVE_OLD_FRAME_CFA_COL}")
-
-#  See pro_init(), HAVE_DWARF2_99_EXTENSION also generates
-#  32bit offset dwarf unless DW_DLC_OFFSET_SIZE_64 flag passed to
-#  pro_init.
-option(HAVE_SGI_IRIX_OFFSETS "Force producer to SGI IRIX offset dwarf" FALSE)
-message(STATUS "Checking  producer generates SGI IRIX output... ${HAVE_SGI_IRIX_OFFSETS}")
-
-option(HAVE_STRICT_DWARF2_32BIT_OFFSET "Force producer to generate only DWARF format 32bit" FALSE)
