=== debian/control ===
--- 
+++ 
@@ -5,10 +5,10 @@
 Build-Depends: debhelper-compat (= 13),
                libelf-dev,
                zlib1g-dev
-Standards-Version: 4.5.0
+Standards-Version: 4.5.1
 Homepage: https://www.prevanders.net/dwarf.html
-Vcs-Git: https://salsa.debian.org/wolff-guest/dwarfutils.git
-Vcs-Browser: https://salsa.debian.org/wolff-guest/dwarfutils
+Vcs-Git: https://salsa.debian.org/wolff/dwarfutils.git
+Vcs-Browser: https://salsa.debian.org/wolff/dwarfutils
 
 Package: dwarfdump
 Architecture: any
