## dwarfutils 20210528

=== libdwarf/CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,5 @@
 set_source_group(SOURCES "Source Files" dwarf_abbrev.c 
-dwarf_alloc.c dwarf_arange.c 
+dwarf_alloc.c dwarf_crc32.c dwarf_arange.c 
 dwarf_debug_sup.c
 dwarf_debuglink.c dwarf_die_deliv.c 
 dwarf_debug_names.c dwarf_dsc.c dwarf_elf_access.c 
@@ -7,7 +7,9 @@
 dwarf_elfread.c 
 dwarf_elf_rel_detector.c 
 dwarf_error.c 
-dwarf_form.c dwarf_frame.c dwarf_frame2.c dwarf_funcs.c 
+dwarf_find_sigref.c dwarf_fission_to_cu.c
+dwarf_form.c dwarf_form_class_names.c
+dwarf_frame.c dwarf_frame2.c dwarf_funcs.c 
 dwarf_gdbindex.c dwarf_global.c 
 dwarf_gnu_index.c dwarf_groups.c 
 dwarf_harmless.c dwarf_generic_init.c dwarf_init_finish.c 
@@ -29,6 +31,7 @@
 dwarf_tsearchhash.c dwarf_types.c dwarf_util.c 
 dwarf_vars.c dwarf_weaks.c dwarf_xu_index.c dwarf_print_lines.c 
 malloc_check.c pro_alloc.c pro_arange.c 
+crc32.c
 pro_debug_sup.c
 pro_die.c pro_dnames.c pro_encode_nm.c pro_error.c pro_expr.c 
 pro_finish.c pro_forms.c pro_funcs.c pro_frame.c 
@@ -83,6 +86,10 @@
 	
 list(LENGTH DWARF_TARGETS targetCount)
 math(EXPR targetCount "${targetCount} - 1")
+list(APPEND DWARF_LIBS ${LIBELF_LIBRARIES})
+if(UNIX)
+    list(APPEND DWARF_LIBS z)
+endif()
 foreach(i RANGE ${targetCount})
 	list(GET DWARF_TARGETS ${i} target)
 	list(GET DWARF_TYPES ${i} type)
@@ -109,10 +116,6 @@
 		ARCHIVE DESTINATION ${LIBDIR})
 endforeach()
 
-if(UNIX AND BUILD_SHARED)
-	target_link_libraries(dwarf-shared PUBLIC z)
-endif()
-		
 if (DO_TESTING)
     set_source_group(TESTLEB "Source Files" dwarf_leb_test.c 
         dwarf_leb.c pro_encode_nm.c )
@@ -133,3 +136,25 @@
     target_compile_options(selftied PRIVATE ${DW_FWALL})
     add_test(NAME teststring COMMAND teststring)
 endif()
+# The install has to be here, not in
+# ../CMakeLists.txt  to make install work properly
+# for cmake before cmake 3.13. This also works
+# for newer cmake.
+add_custom_target(dd DEPENDS ${DWARF_TARGETS} dwarfdump)
+install(TARGETS ${DWARF_TARGETS} EXPORT libdwarfTargets
+    ARCHIVE DESTINATION lib
+    LIBRARY DESTINATION lib)
+install(EXPORT libdwarfTargets
+    FILE libdwarf-targets.cmake
+    NAMESPACE libdwarf::
+    DESTINATION lib/cmake/libdwarf
+)
+install(
+    FILES cmake/libdwarf-config.cmake
+    DESTINATION lib/cmake/libdwarf
+)
+install(DIRECTORY libdwarf DESTINATION include/
+    FILES_MATCHING PATTERN "*.h")
+install(
+    FILES ${CMAKE_CURRENT_BINARY_DIR}/libdwarf/libdwarf.h
+    DESTINATION include/libdwarf)
