=== debian/control ===
--- 
+++ 
@@ -1,11 +1,12 @@
 Source: dwarfutils
-Maintainer: Fabian Wolff <fabi.wolff@arcor.de>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Fabian Wolff <fabi.wolff@arcor.de>
 Section: libs
 Priority: optional
 Build-Depends: debhelper-compat (= 13),
                libelf-dev,
                zlib1g-dev
-Standards-Version: 4.5.1
+Standards-Version: 4.6.0
 Homepage: https://www.prevanders.net/dwarf.html
 Vcs-Git: https://salsa.debian.org/wolff/dwarfutils.git
 Vcs-Browser: https://salsa.debian.org/wolff/dwarfutils
